// LFAssist.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "LFAssist.h"
#include "ShellManager.h"
#include "Association.h"
#include "Utility.h"


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	//R}hC̕
	std::vector<CString> cmdParams;
	int nArgs=UtilGetCommandLineParams(cmdParams);

	if(nArgs<2){
		MessageBox(NULL,_T("Assistant program for LhaForge"),_T("Information"),MB_OK|MB_ICONINFORMATION);
		return 0;	//nothing to do
	}

	//t@C擾
	CString strIniName;
	if(PATHERROR_NONE!=UtilGetCompletePathName(strIniName,cmdParams[1]))return 1;		//ΏۂȂ

	//---INI

	LPCTSTR extArray[]={	//֘AÂΏۂƂȂgq̈ꗗ;ZNV͂ʓ|Ȃ̂ŁB
		_T(".lzh"),
		_T(".lzs"),
		_T(".lha"),
		_T(".zip"),
		_T(".jar"),
		_T(".cab"),
		_T(".7z"),
		_T(".arj"),
		_T(".rar"),
		_T(".jak"),
		_T(".gca"),
		_T(".imp"),
		_T(".ace"),
		_T(".yz1"),
		_T(".hki"),
		_T(".bza"),
		_T(".gza"),
		_T(".ish"),
		_T(".uue"),
		_T(".bel"),
		_T(".tar"),
		_T(".gz"),
		_T(".tgz"),
		_T(".bz2"),
		_T(".tbz"),
		_T(".z"),
		_T(".taz"),
		_T(".cpio"),
		_T(".a"),
		_T(".lib"),
		_T(".rpm"),
		_T(".deb"),
		_T(".iso"),
	};
	const UINT extCount=sizeof(extArray)/sizeof(extArray[0]);

	//֘AÂ̏
	bool bChanged=false;	//ݒ肪ύXtrue
	CString strCmd;	//֘AÂR}h
	{
		CPath tmp(UtilGetModuleDirectoryPath());	//{̂̃pX擾
		tmp+=_T("LhaForge.exe");
		tmp.QuoteSpaces();
		strCmd=(CString)tmp;
		strCmd+=_T(" /m \"%1\"");	//p[^
	}

	for(UINT i=0;i<extCount;i++){
		//ZNV݂邩ǂmF
		TRACE(_T("Processing Assoc:%s\n"),extArray[i]);
		if(UtilCheckINISectionExists(extArray[i],strIniName)){
			TRACE(_T("Section found\n"));
			int nAction=GetPrivateProfileInt(extArray[i],_T("set"),-1,strIniName);
			if(0==nAction){	//֘AÂ폜
				AssocDeleteAssociation(extArray[i]);
			}else if(1==nAction){	//VKɊ֘AÂ쐬
				//Â֘AÂݒ擾
				ASSOCINFO ai;
				ai.Ext=extArray[i];
				AssocGetAssociation(ai);

				//֘AÂR}h
				//GetPrivateProfileString(extArray[i],_T("cmd"),_T(""),szBuffer,sizeof(szBuffer)/sizeof(szBuffer[0])-1,strIniName);
				ai.ShellOpenCommand=strCmd;

				//ACR
				TCHAR szBuffer[_MAX_PATH*2]={0};
				GetPrivateProfileString(extArray[i],_T("iconfile"),_T(""),szBuffer,sizeof(szBuffer)/sizeof(szBuffer[0])-1,strIniName);
				ai.IconFile=szBuffer;
				ai.IconIndex=GetPrivateProfileInt(extArray[i],_T("iconindex"),0,strIniName);

				//ݒs
				AssocSetAssociation(ai);

				bChanged=true;
			}
		}
	}
	if(bChanged){
		::SHChangeNotify(SHCNE_ASSOCCHANGED,SHCNF_FLUSH,NULL,NULL);	//֘At̕ύXVFɒʒm
	}

	//VFg̏
	if(UtilCheckINISectionExists(_T("Shell"),strIniName)){
		//DLL̃pX
		CPath tmp(UtilGetModuleDirectoryPath());
#ifdef WIN64
		tmp+=_T("ShellExtDLL64.dll");
#else
		tmp+=_T("ShellExtDLL.dll");
#endif

		//e
		int nAction=GetPrivateProfileInt(_T("Shell"),_T("set"),-1,strIniName);

		if(0==nAction){
			//
			ShellUnregisterServer(NULL,tmp);
		}else if(1==nAction){
			//Zbg
			ShellRegisterServer(NULL,tmp);
		}

		//ύXVXeɒʒm
		//::SendMessageTimeout(HWND_BROADCAST,WM_SETTINGCHANGE,0L,NULL,SMTO_NORMAL,1000,NULL);
	}

	//ύXVXeɒʒm(\)
//	::SHChangeNotify(SHCNE_ALLEVENTS,SHCNF_FLUSH,NULL,NULL);

	{
		//폜邩ǂ;둀ɂӐ}Ȃ폜h߁ÃL[t[Y܂܂ꍇ̂ݍ폜s悤ɂ
		TCHAR szBuffer[_MAX_PATH*2]={0};
		GetPrivateProfileString(_T("PostProcess"),_T("DeleteMe"),_T(""),szBuffer,sizeof(szBuffer)/sizeof(szBuffer[0])-1,strIniName);
		const CString strKeyPhrase(_T("Please_Delete_Me"));
		if(szBuffer==strKeyPhrase){
			::DeleteFile(strIniName);
		}
	}

	return 0;
}

